OGRE: Ogre::DefaultAxisAlignedBoxSceneQuery Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Public Attributes | List of all members
Ogre::DefaultAxisAlignedBoxSceneQuery Class Reference
Core | Component » Scene

Default implementation of AxisAlignedBoxSceneQuery. More...

`#include <OgreSceneManager.h>`

Inheritance diagram for Ogre::DefaultAxisAlignedBoxSceneQuery:
[legend]

## Public Types
enum | WorldFragmentType { WFT_NONE, WFT_PLANE_BOUNDED_REGION, WFT_SINGLE_INTERSECTION, WFT_CUSTOM_GEOMETRY, WFT_RENDER_OPERATION }
| This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries. More...

## Public Member Functions
| DefaultAxisAlignedBoxSceneQuery (SceneManager *creator)
| ~DefaultAxisAlignedBoxSceneQuery ()
virtual void | clearResults (void)
| Clears the results of the last query execution. More...
bool | execute (ObjectData objData, size_t numNodes, SceneQueryListener *listener)
virtual void | execute (SceneQueryListener *listener)
| See RayScenQuery. More...
virtual SceneQueryResult & | execute (void)
| Executes the query, returning the results back in one list. More...
const AxisAlignedBox & | getBox (void) const
| Gets the box which is being used for this query. More...
virtual SceneQueryResult & | getLastResults (void) const
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute. More...
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query. More...
virtual const set< WorldFragmentType >::type * | getSupportedWorldFragmentTypes (void) const
| Returns the types of world fragments this query supports. More...
virtual WorldFragmentType | getWorldFragmentType (void) const
| Gets the current world fragment types to be returned from the query. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | queryResult (MovableObject *first)
| Self-callback in order to deal with execute which returns collection. More...
bool | queryResult (SceneQuery::WorldFragment *fragment)
| Self-callback in order to deal with execute which returns collection. More...
void | setBox (const AxisAlignedBox &box)
| Sets the size of the box you wish to query. More...
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query. More...
virtual void | setWorldFragmentType (enum WorldFragmentType wft)
| Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed. More...

## Public Attributes
uint8 | mFirstRq
uint8 | mLastRq

## Detailed Description

Default implementation of AxisAlignedBoxSceneQuery.

## Member Enumeration Documentation

## ◆ WorldFragmentType

enum Ogre::SceneQuery::WorldFragmentType
| inherited

This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries.

Not all these types will be supported by all SceneManagers; once the application has decided which SceneManager specialisation to use, it is expected that it will know which type of world geometry abstraction is available to it.

Enumerator
WFT_NONE | Return no world geometry hits at all.
WFT_PLANE_BOUNDED_REGION | Return pointers to convex plane-bounded regions.
WFT_SINGLE_INTERSECTION | Return a single intersection point (typically RaySceneQuery only)
WFT_CUSTOM_GEOMETRY | Custom geometry as defined by the SceneManager.
WFT_RENDER_OPERATION | General RenderOperation structure.

## Constructor & Destructor Documentation

## ◆ DefaultAxisAlignedBoxSceneQuery()

Ogre::DefaultAxisAlignedBoxSceneQuery::DefaultAxisAlignedBoxSceneQuery | ( | SceneManager * | creator | ) |

## ◆ ~DefaultAxisAlignedBoxSceneQuery()

Ogre::DefaultAxisAlignedBoxSceneQuery::~DefaultAxisAlignedBoxSceneQuery | ( |  | ) |

## Member Function Documentation

## ◆ clearResults()

virtual void Ogre::RegionSceneQuery::clearResults | ( | void |  | ) |
| virtualinherited

Clears the results of the last query execution.

Remarks
  You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

## ◆ execute() [1/3]

bool Ogre::DefaultAxisAlignedBoxSceneQuery::execute | ( | ObjectData | objData,
|  | size_t | numNodes,
|  | SceneQueryListener * | listener
| ) |  |

## ◆ execute() [2/3]

virtual void Ogre::DefaultAxisAlignedBoxSceneQuery::execute | ( | SceneQueryListener * | listener | ) |
| virtual

See RayScenQuery.

Implements Ogre::RegionSceneQuery.

## ◆ execute() [3/3]

virtual SceneQueryResult& Ogre::RegionSceneQuery::execute | ( | void |  | ) |
| virtualinherited

Executes the query, returning the results back in one list.

Remarks
  This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

## ◆ getBox()

const AxisAlignedBox& Ogre::AxisAlignedBoxSceneQuery::getBox | ( | void |  | ) | const
| inherited

Gets the box which is being used for this query.

## ◆ getLastResults()

virtual SceneQueryResult& Ogre::RegionSceneQuery::getLastResults | ( | void |  | ) | const
| virtualinherited

Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

## ◆ getQueryMask()

virtual uint32 Ogre::SceneQuery::getQueryMask | ( | void |  | ) | const
| virtualinherited

Returns the current mask for this query.

## ◆ getSupportedWorldFragmentTypes()

virtual const set<WorldFragmentType>::type* Ogre::SceneQuery::getSupportedWorldFragmentTypes | ( | void |  | ) | const
| inlinevirtualinherited

Returns the types of world fragments this query supports.

## ◆ getWorldFragmentType()

virtual WorldFragmentType Ogre::SceneQuery::getWorldFragmentType | ( | void |  | ) | const
| virtualinherited

Gets the current world fragment types to be returned from the query.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ queryResult() [1/2]

bool Ogre::RegionSceneQuery::queryResult | ( | MovableObject * | first | ) |
| virtualinherited

Self-callback in order to deal with execute which returns collection.

Implements Ogre::SceneQueryListener.

## ◆ queryResult() [2/2]

bool Ogre::RegionSceneQuery::queryResult | ( | SceneQuery::WorldFragment * | fragment | ) |
| virtualinherited

Self-callback in order to deal with execute which returns collection.

Implements Ogre::SceneQueryListener.

## ◆ setBox()

void Ogre::AxisAlignedBoxSceneQuery::setBox | ( | const AxisAlignedBox & | box | ) |
| inherited

Sets the size of the box you wish to query.

## ◆ setQueryMask()

virtual void Ogre::SceneQuery::setQueryMask | ( | uint32 | mask | ) |
| virtualinherited

Sets the mask for results of this query.

Remarks
  This method allows you to set a 'mask' to limit the results of this query to certain types of result. The actual meaning of this value is up to the application; basically MovableObject instances will only be returned from this query if a bitwise AND operation between this mask value and the MovableObject::getQueryFlags value is non-zero. The application will have to decide what each of the bits means. The default initial query mask of a SceneQuery is SceneManager::QUERY_ENTITY_DEFAULT_MASK

Note
  By default, Ogre uses @SceneManager::QUERY_ENTITY_DEFAULT_MASK and Co. to set each type of MovableObject's default query mask. This behavior can be overriden though, just set the masks you don't need to 0 before creating those objects.

## ◆ setWorldFragmentType()

virtual void Ogre::SceneQuery::setWorldFragmentType | ( | enum WorldFragmentType | wft | ) |
| virtualinherited

Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.

Remarks
  The application receiving the world geometry is expected to know what to do with it; inevitably this means that the application must have knowledge of at least some of the structures used by the custom SceneManager.

  The default setting is WFT_NONE.

## Member Data Documentation

## ◆ mFirstRq

uint8 Ogre::SceneQuery::mFirstRq
| inherited

## ◆ mLastRq

uint8 Ogre::SceneQuery::mLastRq
| inherited

The documentation for this class was generated from the following file:

- OgreSceneManager.h